unit MTypes;

interface

{--------------------------------------------------------------------------}

{declare constants}
const
{regions}
 NORTH     = 1;
 SOUTH     = 2;
 EAST      = 3;
 WEST      = 4;
 CENTER    = 5;

{items}
 FACTORIES = 1;
 ARMIES    = 2;
 ABMS      = 3;
 NICBMS    = 4;
 NNICBMS   = 5;

{actions}
 ATTACK    = 1;
 MOVE      = 2;

{--------------------------------------------------------------------------}

{declare data types}
type

{record to store a single unit event}
 actionque = record
  item:integer;
  action:integer;
  quantity:integer;
  o_cont:integer;
  o_region:integer;
  d_cont:integer;
  d_region:integer;
 end;

{array to store a list of action ques}
 quelist = array[1..50] of actionque;


{array to store placement data for a specific continental region}
 pltype = array[NORTH..CENTER] of integer;

 plrec1 = record
  cont:integer;
  region:integer;
  data:integer;
 end;

 pllist = array[1..20] of plrec1;

{array to store data for object placement routines}
 plrec  = array[1..4,NORTH..CENTER] of integer;

{record to store all the data for a single continent}
 continent = record
  own:pltype;       {who owns the region}
  factories:pltype; {how many factories}
  armies:pltype;    {how many armies}
  ABMs:pltype;      {how many anti-ICBM missiles}
  NICBMs:pltype;    {how many thermonuclear ICBMs}
  NNICBMs:pltype;   {how many conventional ICBMs}
 end;

{array to store placement data for the whole world}
 worldtype = array[1..4] of continent;

{record to store data for a specific player}
 playertype = record
  name:string;                     {player's name}
  money:longint;                   {player's money}
  pu:integer;                      {plauer's production units}
  intelsat:array[1..4] of boolean; {player's spy satelites}
  que:quelist;                     {player's attack action que}
  qnum:integer;                    {length of que}
 end;

{array to store player data for all the players}
 playerstype = array[1..4] of playertype;

{generic item list array for the menu procedure}
 itemlist = array[1..20] of string;

{--------------------------------------------------------------------------}
{declare global variables}
var
 numply:integer;     {number of players in game}
 player:playerstype; {players' data}
 board:worldtype;    {placement data}
 i:integer;          {generic counting index variable for main program}

implementation


end.
